# $Id: server.py 341 2007-04-25 11:58:48Z jcea $
#
# (c) 2006-2007 jcea@argo.es / jcea@hispasec.com
#
# PGP/GPG Public Key:
# pub   1024R/9AC53D4D 1995-01-01
#       Key fingerprint = F4 07 90 C2 58 86 8A 75  45 40 33 1C 72 4C E5 E1
# uid                  Jesus Cea Avion <jcea@hispasec.com>
# uid                  Jesus Cea Avion <jcea@argo.es>
#
# This product is covered by the GNU PUBLIC LICENSE, VERSION 2.
# For more detailt, read the file "LICENSE" in the distribution.


# This code is basically a copy of standard "durus" launch code.

import sys
import socket
from optparse import OptionParser
from durus.storage_server import DEFAULT_PORT, DEFAULT_HOST, StorageServer
from durus.logger import log, logger, direct_output

def start() :
  logfile = sys.stderr
  direct_output(logfile)

  from berkeleydb_storage import BerkeleyDBStorage
  storage = BerkeleyDBStorage("db")
  host=DEFAULT_HOST
  port=DEFAULT_PORT
  log(20, 'host=%s port=%s', host, port)
  StorageServer(storage, host=host, port=port).serve()

if __name__=="__main__" :
  start()

