# $Id: parser_smileys.py 481 2007-11-12 15:22:24Z jcea $

from globales import monitor

@monitor
def get_smiley_list(conn):
  import database
  return database.get_smiley_list(conn)

smiley_list = get_smiley_list()

def parse(text, context = None):
  import re
  if context == "code":
    return len(text), text, None, [], None

  min = len(text)
  min_sm = None
  for smiley in smiley_list:
    aux = text.find(smiley[0])
    if -1 < aux < min:
      min = aux
      min_sm = smiley
  if min_sm:
    img = '<img alt="%s" src="/static/smileys/%s" />' % min_sm
    ret = text.split(min_sm[0], 1)
    before = ret[0]
    pos = len(before)
    args = None
    tag = None
    after = ret[1]
    return pos, before, ("TEXT",img), args, after
  return len(text), text, None, [], None
