# $Id: url_edit_config_POST.py 407 2007-10-19 05:14:10Z jcea $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if usuario!="master" : # Acceso anonimo
    return None

  if len(path)!=1 : return None

  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)

  import database
  root=conn.get_root()
  conf=root["config"]
  new_conf={}
  for k,v in conf.items() :
    t=type(v)
    if type(True)==t :
      v=cuerpo.getfirst(k,"*")   # If we don't have a value, then false
      new_conf[k]=(v!="*")
    elif type(0)==t :
      v=cuerpo.getfirst(k)
      try :
        v=int(v)   # Be sure it is present and a number
      except :
        return None
      new_conf[k]=v
    elif type("")==t :
      v=cuerpo.getfirst(k)
      if v==None : return None   # Be sure it is present
      new_conf[k]=v
    else :
      return None # Error!!
  # conf.clear() # Don't need "clear", since keys are overwritten

  tz=new_conf["tz"]
  if conf["tz"]!=tz :
    try :
      import pytz
      pytz.timezone(tz)  # Comprobamos si esa zona es valida
    except :
      import skins
      pagina = skins.Skin(path,usuario)
      pagina.load_dict({"page_title": "cpif - Cambio de configuraci&oacute;n erroneo"})
      pagina.load_url(["error"])
      pagina.load_dict({"generic_message": "<h1>La zona horaria especificada es inv&aacute;lida</h1>"})
      return pagina.web()

    database.usuario_update(conn,"",TZ=tz)

  conf.update(new_conf) # Be careful, since the dictionary is persistent

# We do a commit here to be sure we store the
# new configuration before activating it.
# This code should be the very last code in this function.
  conn.commit()
  database.load_new_config(new_conf)

  return (200,{"Content-Type":"text/plain; charset=utf-8"},"Cambio de configuracion CPIF efectuado")

