# $Id: url_edit_metatags_POST.py 493 2007-11-13 18:44:16Z jcea $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if usuario!="master" :
    return None

  if len(path)!=1 : return None

  import database

  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)

  usuarios=conn.get_root()["usuarios"]["usuarios"]
  metatags=conn.get_root()["metatags"]["metatags"]
  grupos={}
  for i,j in conn.get_root()["grupos"]["grupos"].items() :
    grupos[j["nombre"]]=i
  for n in conn.get_root()["metatags"]["publicos"] :
    metatag=metatags[n]
    metatag_nuevo_nombre=cuerpo.getfirst("metatag%d" %n)
    metatag_nuevos_usuarios_moderadores=cuerpo.getfirst("user_moderators%d" %n)
    metatag_nuevos_grupos_moderadores=cuerpo.getfirst("group_moderators%d" %n)

    if metatag_nuevo_nombre==None or \
       metatag_nuevos_usuarios_moderadores==None or \
       metatag_nuevos_grupos_moderadores==None : return None

    metatag_nuevo_nombre=metatag_nuevo_nombre.strip()
    if metatag_nuevo_nombre :
      metatag["nombre"]=metatag_nuevo_nombre

    if metatag_nuevos_usuarios_moderadores :
      metatag_nuevos_usuarios_moderadores=metatag_nuevos_usuarios_moderadores.split(",")
    else :
      metatag_nuevos_usuarios_moderadores=[]
    if metatag_nuevos_usuarios_moderadores!=metatag["usuarios moderadores"] :
      for i in metatag_nuevos_usuarios_moderadores :
        i2=i.strip()
        if i2=="" : i2=" <NO VALID> " # No puedes poner como moderador al usuario anonimo...
        else : i2=database.normaliza_nick(i)
        if i2 not in usuarios :
            return (200, {"Content-Type":"text/html; charset=utf-8"},"El usuario '%s' no existe en el sistema" %i)
      metatag["usuarios moderadores"]=metatag_nuevos_usuarios_moderadores

    if metatag_nuevos_grupos_moderadores :
      metatag_nuevos_grupos_moderadores=metatag_nuevos_grupos_moderadores.split(",")
    else :
      metatag_nuevos_grupos_moderadores=[]
    grupos_moderadores=set()
    for i in metatag_nuevos_grupos_moderadores :
      i=i.strip()
      if i not in grupos :
        return (200, {"Content-Type":"text/html; charset=utf-8"},"El grupo '%s' no existe en el sistema" %i)
      grupos_moderadores.add(grupos[i])
    if grupos_moderadores!=metatag["grupos moderadores"] :
      metatag["grupos moderadores"]=grupos_moderadores

  categorias=cuerpo.getfirst("categorias")
  if categorias==None : return None
  if categorias!=repr(list(conn.get_root()["metatags"]["categorias"])) :
    class safe_eval(object) :
      def visit(self,node) :
        meth=getattr(self,"visit"+node.__class__.__name__)
        return meth(node)
      def visitExpression(self,node) :
        for i in node.getChildNodes() :
          return self.visit(i)
      def visitConst(self,node) :
        return node.value
      def visitList(self,node) :
        return [self.visit(i) for i in node.nodes]

    import compiler
    from types import ListType,StringType
    try :
      ast=compiler.parse(categorias,"eval")
      categorias=safe_eval().visit(ast)
      assert isinstance(categorias,ListType)
      publicos=set(conn.get_root()["metatags"]["publicos"])  # No debemos alterar el original, que es persistente
      for i in categorias :
        assert isinstance(i,ListType)
        if len(i)==1 :
          publicos.remove(i[0])
        else :
          assert isinstance(i[0],StringType)
          for j in i[1:] :
            publicos.remove(j)
      assert len(publicos)==0
    except :
      return (200, {"Content-Type":"text/html; charset=utf-8"},"El formato especificado para las categor&iacute;as es inv&aacute;lido")
    from durus.persistent_list import PersistentList
    conn.get_root()["metatags"]["categorias"]=PersistentList(categorias)

  metatag_nuevo=cuerpo.getfirst("metatag_new")
  if metatag_nuevo==None : return None
  metatag_nuevo=metatag_nuevo.strip()
  if metatag_nuevo :
    database.metatag_add(conn,metatag_nuevo)

  return (302,{"Location":"/"},"")

