# $Id: url_perfil.py 404 2007-10-17 23:22:26Z jcea $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if not usuario : # Acceso anonimo
    return None

  limited_profile=False

  l=len(path)
  if l==1 :
    usuario_pedido=usuario
  elif l==2 :
    usuario_pedido=path[1]
  else :
    return None

  import database
  usuario_pedido_normalizado=database.normaliza_nick(usuario_pedido)
  if usuario!="master" :
    if database.normaliza_nick(usuario)!=usuario_pedido_normalizado :
      limited_profile=True

  root=conn.get_root()
  u=root["usuarios"]["usuarios"].get(usuario_pedido_normalizado)
  if not u :
    return None

  if limited_profile :
    return (200, {"Content-Type":"text/html; charset=utf-8"},
"""
<html>
<title>Enviar mensaje a %(usuario_pedido)s</title>
<body>
<h1>Enviar mensaje a %(usuario_pedido)s</h1>
<form action="/nuevo_hilo_privado_POST" method="post" enctype="multipart/form-data">
 <label for="titulo">T&iacute;tulo:</label> <input type="text" name="titulo" id="titulo" size="60" value="" /><br />
 <label for="texto">Texto:</label><textarea name="texto" id="texto" rows="10" cols="60"></textarea><br />
 <input type="hidden" name="usuario_pedido_normalizado" value="%(usuario_pedido_normalizado)s"/>
 <input class="form-element" type="submit" name="submit" value="Publicar nuevo hilo privado"/>
</form>
</body>
</html>
""" % {"usuario_pedido":usuario_pedido,"usuario_pedido_normalizado":usuario_pedido_normalizado})
  else :
    import skins
    pagina = skins.Skin(path,usuario)
    advise = "(Se ha solicitado un cambio de direcci&oacute;n de correo electr&oacute;nico, y est&aacute; pendiente de confirmaci&oacute;n)" if "new email" in u else ""
    OpenIDs=list(u["OpenID"])+["","","","",""] # Padding
    d = {
          "page_title": "cpif - perfil %s" % usuario,
          "profile user": "%s %s" % (usuario_pedido, "<b><i>&iexcl;&iexcl;NO LOGIN!!</i></b>" if "no_login" in u else ""),
          "profile email": "%s %s" % (u["email"], advise),
          "profile openid1": "%s" % OpenIDs[0],
          "profile openid2": "%s" % OpenIDs[1],
          "TZ": u["tz"],
          "avatar": u["avatar"],
      }
    for i,j in zip([3,4,5],OpenIDs[2:]):
      d["profile openid%d" % i] =  "%s" % j
    pagina.load_dict(d)

    return (pagina.web())
