# $Id: load_smileys.py 323 2007-08-02 08:33:11Z jcea $

# To load the smiley data, CPIF server must be stopped first.

def main() :
  # Several smiley-codes can point to the same image file.
  # If you repeat a smiley-code, the loading process will
  # detect it and will give an error.
  # The directory separator is "/", even if your OS use
  # another symbol; the correct symbol will be automatically
  # replaced when doing the disk access.
  smileys=[
    (":buey:","buey_smiley.gif"),
    (":zoidberg:","zoidberg.gif"),
    (":cabezazo:","cabezazo2.gif"),
    (":yuhu:","yuhu.gif"),
#    (":-)","smile.gif"),
#    (":)","smile.gif"),

    (":D","phpBB3/icon_e_biggrin.gif"),
    (":-D","phpBB3/icon_e_biggrin.gif"),
    (":grin:","phpBB3/icon_e_biggrin.gif"),
    (":)","phpBB3/icon_e_smile.gif"),
    (":-)","phpBB3/icon_e_smile.gif"),
    (":smile:","phpBB3/icon_e_smile.gif"),
    (";)","phpBB3/icon_e_wink.gif"),
    (";-)","phpBB3/icon_e_wink.gif"),
    (":wink:","phpBB3/icon_e_wink.gif"),
    (":(","phpBB3/icon_e_sad.gif"),
    (":-(","phpBB3/icon_e_sad.gif"),
    (":sad:","phpBB3/icon_e_sad.gif"),
    (":o","phpBB3/icon_e_surprised.gif"),
    (":-o","phpBB3/icon_e_surprised.gif"),
    (":eek:","phpBB3/icon_e_surprised.gif"),
    (":shock:","phpBB3/icon_eek.gif"),
    (":?","phpBB3/icon_e_confused.gif"),
    (":-?","phpBB3/icon_e_confused.gif"),
    (":???:","phpBB3/icon_e_confused.gif"),
    ("8-)","phpBB3/icon_cool.gif"),
    (":cool:","phpBB3/icon_cool.gif"),
    (":lol:","phpBB3/icon_lol.gif"),
    (":x","phpBB3/icon_mad.gif"),
    (":-x","phpBB3/icon_mad.gif"),
    (":mad:","phpBB3/icon_mad.gif"),
    (":P","phpBB3/icon_razz.gif"),
    (":-P","phpBB3/icon_razz.gif"),
    (":razz:","phpBB3/icon_razz.gif"),
    (":oops:","phpBB3/icon_redface.gif"),
    (":cry:","phpBB3/icon_cry.gif"),
    (":evil:","phpBB3/icon_evil.gif"),
    (":twisted:","phpBB3/icon_twisted.gif"),
    (":roll:","phpBB3/icon_rolleyes.gif"),
    (":!:","phpBB3/icon_exclaim.gif"),
    (":?:","phpBB3/icon_question.gif"),
    (":idea:","phpBB3/icon_idea.gif"),
    (":arrow:","phpBB3/icon_arrow.gif"),
    (":|","phpBB3/icon_neutral.gif"),
    (":-|","phpBB3/icon_neutral.gif"),
    (":mrgreen:","phpBB3/icon_mrgreen.gif"),
    (":geek:","phpBB3/icon_e_geek.gif"),
    (":ugeek:","phpBB3/icon_e_ugeek.gif"),
  ]

  import os.path,sys
  directorio_padre=os.path.split(os.getcwd())[0]  # Directorio padre
  sys.path.append(os.path.join(directorio_padre,"backend"))

  import storage
  dummy,dummy,monitor=storage.storage_and_monitor(os.path.join(os.path.pardir,"backend","db"))

  import database
  database.init_database(monitor)

  @monitor
  def load(conn,smileys) :
    database.smileys_update(conn,smileys,"smileys")
    
  load(smileys)
  print "Hemos cargado %d smileys" %len(smileys)


if __name__=="__main__" :
  main()

