# $Id: url_edit_grupos.py 471 2007-11-08 22:37:42Z alvaro $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if len(path)!=1 : return None

  if usuario!="master" :
    import skins
    pagina = skins.Skin(path,usuario)
    pagina.load_dict({"page_title": "cpif - Grupos editados con exito"})
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>Solo el usuario master puede editar grupos</h1>"})
    return (pagina.web())

  root=conn.get_root()

  texto=['<tr><th colspan="2">Cambiar los nombres de los grupos</th><td>usuarios</td></tr>']
  for num_grupo,grupo in root["grupos"]["grupos"].items() :
    nombre=grupo["nombre"]
    usuarios=",".join(grupo["usuarios"])
    texto.append('<tr><td>%s</td><td><input type="text" name="grupo%d" size="60" value="" /></td> \
                      <td><input type="text" name="usuarios%d" size="40" value="%s" /></td></tr>'
                      % (nombre,num_grupo,num_grupo,usuarios))

  texto.append('<tr><td>&nbsp;</td><td>&nbsp;</td></tr>')

  texto.append('<tr><td>Crear grupo nuevo</td><td><input type="text" name="grupo_new" size="60" value="" /></td></tr>')

  return (200, {"Content-Type":"text/html; charset=utf-8"}, 
"""
<html>
<title>Editar Grupos</title>
<body>
<form action="/edit_grupos_POST" method="post" enctype="multipart/form-data">
<table>
%s
<tr><td colspan="2" align="right"><input type="submit" name="submit" value="actualizar grupos"/></td></tr>
</table>
</body>
</html>
""" % ("\r\n".join(texto)))

