# $Id: url_edit_metatags.py 492 2007-11-13 18:39:30Z jcea $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if len(path)!=1 : return None

  if usuario!="master" :
    import skins
    pagina = skins.Skin(path,usuario)
    pagina.load_dict({"page_title": "cpif - metatags editados con exito"})
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>Solo el usuario master puede editar metatags</h1>"})
    return (pagina.web())

  root=conn.get_root()
  grupos=root["grupos"]["grupos"]

  texto=['<tr><th colspan="2">Cambiar los nombres de los metatags</th><td>Moderadores</td></tr>']
  metatags=root["metatags"]["metatags"]
  for num_metatag in root["metatags"]["publicos"] :
    metatag=metatags[num_metatag]
    nombre=metatag["nombre"]
    usuarios_moderadores=",".join(metatag["usuarios moderadores"])
    grupos_moderadores=",".join([grupos[i]["nombre"] for i in metatag["grupos moderadores"]])
    texto.append('<tr><td>%s<br>C&oacute;digo %d</td><td><input type="text" name="metatag%d" size="60" value="" /></td> \
                      <td><input type="text" name="user_moderators%d" size="40" value="%s" /></td></tr>'
                      % (nombre,num_metatag,num_metatag,num_metatag,usuarios_moderadores))
    texto.append('<tr><td colspan="2" align="right">Grupos:</td> \
                      <td><input type="text" name="group_moderators%d" size="30" value="%s" /></td></tr>'
                      % (num_metatag,grupos_moderadores))


  texto.append('<tr><td>&nbsp;</td><td>&nbsp;</td></tr>')

  texto.append('<tr><td>Crear metatag nuevo</td><td><input type="text" name="metatag_new" size="60" value="" /></td></tr>')

  texto.append('<tr><td>&nbsp;</td><td>&nbsp;</td></tr>')

  texto.append('<tr><td>Listado de categor&iacute;as</td><td colspan="2"><input type="text" name="categorias" size="100" value="%s" /></td></tr>' %list(root["metatags"]["categorias"]))

  return (200, {"Content-Type":"text/html; charset=utf-8"}, 
"""
<html>
<title>Editar Metatags</title>
<body>
<form action="/edit_metatags_POST" method="post" enctype="multipart/form-data">
<table>
%s
<tr><td colspan="2" align="right"><input type="submit" name="submit" value="actualizar metatags"/></td></tr>
</table>
</body>
</html>
""" % ("\r\n".join(texto)))

