# $Id: url_hilo.py 494 2007-11-13 18:59:36Z jcea $

from globales import monitor,thread_len

@monitor
def gestiona_url(conn,handler,path,usuario) :
  import time,database,calendario
  l=len(path)
  if l<2 and l>3 :
    return None

  try :
    hilo_num=int(path[1])
  except :
    return None

  first_post=1
  if l==3 :
    try :
      first_post=int(path[2])
    except :
      return None

  if not database.user_has_thread_access(conn,usuario,hilo_num) : return None
  meta,mensajes,num_mensajes,finished,metatags,mon=database.listado_hilo(conn,usuario,hilo_num,first_post)
  if not meta : return None

  if len(metatags)==1 :
    metatag=metatags[0]
  else :
    mts=conn.get_root()["usuarios"]["usuarios"][database.normaliza_nick(usuario)]["punto de lectura no leidos"]
    for metatag in metatags :
      if metatag[0] in mts : break  # Siempre hay al menos uno

  import skins 
  pagina = skins.Skin(path,usuario,handler.headers)

  d = {
      "page_title":"cpif - %s" % meta["titulo"],
      "thread_title": meta["titulo"],
      "thread_author": meta["creador"],
      "thread_num": hilo_num,
      "messages": (first_post,num_mensajes,mensajes),
      "metatag": metatag[0],
      "metatag_title": metatag[1],
      "monitor": mon,
      "read only": meta["read only"],
      "tz": database.usuario_get_tz(conn,usuario)  # Also valid if anonymous
      }

  pagina.load_dict(d)
  return(pagina.web())


