# $Id: url_toggle_monitor_AJAX.py 311 2007-07-30 17:32:01Z jcea $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if len(path)!=3 : return None
  if not usuario : return None  # Acceso anonimo
  try :
    tipo=path[1]
    if (tipo!="thread") and (tipo!="metatag") :
      return None
    num=int(path[2])
  except :
    return None

  from database import toggle_monitor_metatag,toggle_monitor_thread
  func=toggle_monitor_metatag if (tipo=="metatag") else toggle_monitor_thread
  error,status=func(conn,usuario,num)
  if error :
    msg=error
  else :
    if status :
      msg="Dejar de monitorizar"
    else :
      msg="Monitorizar"

  from xml.sax.saxutils import escape
  return (200,{"Content-Type":"text/xml; charset=utf-8"},
"""<?xml version="1.0" ?>
<root>
<msg>%s</msg>
</root>
""" %(escape(msg)))

