# $Id: smileys.py 266 2007-07-11 21:19:25Z heimy $

import re
from nodes import TextNode, MatchObject

class SmileyNode(TextNode):
    pass

risitas = {
    ':)': "<img src='/smileys/happy.png' />",
    ';)': "<img src='/smileys/wink.png' />",
    ':(': "<img src='/smileys/sad.png' />",
    }

class Grammar(object):
    def search(self, strng):
        matches = sorted( (strng.find(x), x) for x in risitas if x in strng )
        if matches:
            pos, key = matches[0]
            return MatchObject(self, key, pos, pos + len(key))
        return MatchObject(self, None, 0, 0)
    def get_nodes(self, parser, key):
        return SmileyNode(risitas[key])
